<p-table #dt [scrollable]="true" [value]="users" selectionMode="single"
    (onRowSelect)="displayModal($event.data)"
    (onRowUnselect)="displayModal(null)" styleClass="p-datatable-striped"
    tableStyleClass="table-with-action-buttons">
    <ng-template pTemplate="caption">
      <div style="text-align:center">Employees</div>
      <div class="d-flex justify-content-between align-items-center">
          <div class="flex-grow-1 text-center">
              <input type="text" pInputText size="50" placeholder="Search"
                  (input)="dt.filter(getEventValue($event), 'name', 'contains')" class="form-control p-inputtext" />
          </div>
      </div>
  </ng-template>
    <ng-template pTemplate="header">
        <tr>
            <th class="rowStyle">Name</th>
            <th style="width: 37px">
              <button pButton icon="fa fa-plus" (click)="onAddUser()" [disabled]="!currentProject"></button>
          </th>
        </tr>
    </ng-template>
    <ng-template pTemplate="body" let-user>
      <tr [pSelectableRow]="user">
          <td>{{user.name}}</td>
          <td>
            <div class="d-flex justify-content-between">
                <button pButton class="p-button-danger" icon="fa fa-times" (click)="onRemoveUser(user)"></button>
            </div>
        </td>
      </tr>
  </ng-template>
  </p-table>


  <p-dialog header="Edit" [(visible)]="editDialogVisible" [responsive]="true" [resizable]="false" showEffect="fade"
  [modal]="true" [style]="{ width: '700px' }">
  <form [formGroup]="editEmployeeForm" (ngSubmit)="onSaveEmployee()">
    <div class="form-group form-row" style="margin-top: 1rem">
      <div class="col">
        <label for="startDate">Start Date</label>
        <p-calendar formControlName="startDate"
                    [readonlyInput]="true"
                    [showIcon]="true"
                    [monthNavigator]="true"
                    [yearNavigator]="true"
                    [appendTo]="'body'"
                    [baseZIndex]="10000"
                    [showClear]="true"
                    [showButtonBar]="true"
                    [minDate]="minDate"
                    class="m-1">
        </p-calendar>
        <div class="text-danger" *ngIf="editEmployeeForm.get('startDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
        <div class="text-danger" *ngIf="editEmployeeForm.get('startDate').errors?.beforeMinDate">Please select a date after {{ minDate | date: 'MM/dd/yyyy' }}</div>
      </div>
      <div class="col">
        <label for="endDate">End Date</label>
        <p-calendar formControlName="endDate"
                    [readonlyInput]="true"
                    [showIcon]="true"
                    [monthNavigator]="true"
                    [yearNavigator]="true"
                    [appendTo]="'body'"
                    [baseZIndex]="10000"
                    [showClear]="true"
                    [showButtonBar]="true"
                    [minDate]="minDate"
                    class="m-1">
        </p-calendar>
        <div class="text-danger" *ngIf="editEmployeeForm.get('endDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
        <div class="text-danger" *ngIf="editEmployeeForm.get('endDate').errors?.beforeMinDate">Please select a date after {{ minDate | date: 'MM/dd/yyyy' }}</div>
      </div>
    </div>
    <small class="text-danger" *ngIf="editEmployeeForm.errors?.dateRange">Start date must be before end date</small>
    <div class="form-group form-row align-items-center mt-1">
      <div class="col-md-6 d-flex align-items-center">
        <p-inputSwitch formControlName="isUnlimited" class="m-1"/>
        <label for="isUnlimited">Unlimited</label>
      </div>
    </div>
    <div class="form-group form-row mt-1" *ngIf="!editEmployeeForm.get('isUnlimited').value">
      <div class="col">
        <label for="hours">Hours (Already reported hours: {{editUserProject?.totalInternalHours}})</label>
        <input 
        type="number" 
        pInputText 
        formControlName="hours" 
        id="hours" 
        class="form-control" 
        (input)="sanitizeEditNumericInput($event)" />
        <small class="text-danger" *ngIf="editEmployeeForm.get('hours').errors?.['min']">Hours must be between 0 and 5000</small>
        <small class="text-danger" *ngIf="editEmployeeForm.get('hours')?.errors?.['max']">Hours must be between 0 and 5000</small>
        <small class="text-danger" *ngIf="editEmployeeForm.get('hours')?.errors?.['pattern']">Invalid input: only numeric values are allowed</small>
      </div>
    </div>
    <div class="form-group form-row">
      <div class="col-12 text-right">
        <button pButton label="Save" [disabled]="editEmployeeForm.invalid" type="submit"></button>
      </div>
    </div>
  </form>
</p-dialog>


<p-dialog header="Add Employee" [(visible)]="addDialogVisible" [responsive]="true" [resizable]="false" showEffect="fade"
  [modal]="true" [style]="{ width: '700px' }">
  <form [formGroup]="addEmployeeForm" (ngSubmit)="addUser()">
    <div class="form-group form-row" style="margin-top: 1rem">
      <div class="col">
        <label for="newUser">Employee</label>
        <p-dropdown formControlName="newUser" [options]="availableUsers" [(ngModel)]="newUser"
          [style]="{ width: '100%' }" appendTo="body" class="m-1" [filter]="true">
        </p-dropdown>
      </div>
    </div>
    <div class="form-group form-row" style="margin-top: 1rem">
      <div class="col">
        <label for="startDate">Start Date</label>
        <p-calendar formControlName="startDate"
                    [readonlyInput]="true"
                    [showIcon]="true"
                    [monthNavigator]="true"
                    [yearNavigator]="true"
                    [appendTo]="'body'"
                    [baseZIndex]="10000"
                    [showClear]="true"
                    [showButtonBar]="true"
                    [minDate]="minDate"
                    [readonlyInput]="true"
                    class="m-1">
        </p-calendar>
        <div class="text-danger" *ngIf="addEmployeeForm.get('startDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
        <div class="text-danger" *ngIf="addEmployeeForm.get('startDate').errors?.beforeMinDate">Please select a date after {{ minDate | date: 'MM/dd/yyyy' }}</div>
      </div>
      <div class="col">
        <label for="endDate">End Date</label>
        <p-calendar formControlName="endDate"
                    [readonlyInput]="true"
                    [showIcon]="true"
                    [monthNavigator]="true"
                    [yearNavigator]="true"
                    [appendTo]="'body'"
                    [baseZIndex]="10000"
                    [showClear]="true"
                    [showButtonBar]="true"
                    [minDate]="minDate"
                    class="m-1">
        </p-calendar>
        <div class="text-danger" *ngIf="addEmployeeForm.get('endDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
        <div class="text-danger" *ngIf="addEmployeeForm.get('endDate').errors?.beforeMinDate">Please select a date after {{ minDate | date: 'MM/dd/yyyy' }}</div>
      </div>
    </div>
    <small class="text-danger" *ngIf="addEmployeeForm.errors?.dateRange">Start date must be before end date</small>
    <div class="form-group form-row align-items-center mt-1">
      <div class="col-md-6 d-flex align-items-center">
        <p-inputSwitch formControlName="isUnlimited" class="m-1"/>
        <label for="isUnlimited">Unlimited</label>
      </div>
    </div>
    <div class="form-group form-row mt-1" *ngIf="!addEmployeeForm.get('isUnlimited').value">
      <div class="col">
        <label for="hours">Hours</label>
        <input 
        type="number" 
        pInputText 
        formControlName="hours" 
        id="hours" 
        class="form-control" 
        (input)="sanitizeAddNumericInput($event)" />
        <small class="text-danger" *ngIf="addEmployeeForm.get('hours').errors?.['min']">Hours must be between 1 and 5000</small>
        <small class="text-danger" *ngIf="addEmployeeForm.get('hours').errors?.['max']">Hours must be between 1 and 5000</small>
        <small class="text-danger" *ngIf="addEmployeeForm.get('hours')?.errors?.['pattern']">Invalid input: only numeric values are allowed</small>
      </div>
    </div>
    <div class="form-group form-row">
      <div class="col-12 text-right">
        <button pButton label="Save" [disabled]="addEmployeeForm.invalid" type="submit"></button>
      </div>
    </div>
  </form>
</p-dialog>
